## python-coverage 7.8.2+dfsg1

=== Makefile ===
# Licensed under the Apache License: http://www.apache.org/licenses/LICENSE-2.0
# For details: https://github.com/nedbat/coveragepy/blob/master/NOTICE.txt

# Makefile for utility work on coverage.py.

.DEFAULT_GOAL := help


##@ Utilities

.PHONY: help _clean_platform debug_clean clean_platform clean sterile install

help:					## Show this help.
	@# Adapted from https://www.thapaliya.com/en/writings/well-documented-makefiles/
	@echo Available targets:
	@awk -F ':.*##' '/^[^: ]+:.*##/{printf "  \033[1m%-20s\033[m %s\n",$$1,$$2} /^##@/{printf "\n%s\n",substr($$0,5)}' $(MAKEFILE_LIST)

_clean_platform:
	@rm -f *.so */*.so
	@rm -f *.pyd */*.pyd
	@rm -rf __pycache__ */__pycache__ */*/__pycache__ */*/*/__pycache__ */*/*/*/__pycache__ */*/*/*/*/__pycache__
	@rm -f *.pyc */*.pyc */*/*.pyc */*/*/*.pyc */*/*/*/*.pyc */*/*/*/*/*.pyc
	@rm -f *.pyo */*.pyo */*/*.pyo */*/*/*.pyo */*/*/*/*.pyo */*/*/*/*/*.pyo
	@rm -f *$$py.class */*$$py.class */*/*$$py.class */*/*/*$$py.class */*/*/*/*$$py.class */*/*/*/*/*$$py.class

debug_clean:				## Delete various debugging artifacts.
	@rm -rf /tmp/dis $$COVERAGE_DEBUG_FILE

clean: debug_clean _clean_platform	## Remove artifacts of test execution, installation, etc.
	@echo "Cleaning..."
	@-pip uninstall -yq coverage
	@mkdir -p build	# so the chmod won't fail if build doesn't exist
	@chmod -R 777 build
	@rm -rf build coverage.egg-info dist htmlcov
	@rm -f *.bak */*.bak */*/*.bak */*/*/*.bak */*/*/*/*.bak */*/*/*/*/*.bak
	@rm -f coverage/*,cover
	@rm -f MANIFEST
	@rm -f .coverage .coverage.* .metacov*
	@rm -f coverage.xml coverage.json
	@rm -f .tox/*/lib/*/site-packages/zzz_metacov.pth
	@rm -f */.coverage */*/.coverage */*/*/.coverage */*/*/*/.coverage */*/*/*/*/.coverage */*/*/*/*/*/.coverage
	@rm -f tests/covmain.zip tests/zipmods.zip tests/zip1.zip
	@rm -rf doc/_build doc/_spell doc/sample_html_beta
	@rm -rf tmp
	@rm -rf .*cache */.*cache */*/.*cache */*/*/.*cache .hypothesis
	@rm -rf tests/actual
	@-make -C tests/gold/html clean

sterile: clean				## Remove all non-controlled content, even if expensive.
	rm -rf .tox
	rm -f cheats.txt

# For installing development tooling, use uv if it's available, otherwise pip.
HAS_UV := $(shell command -v uv 2>/dev/null)
ifdef HAS_UV
	INSTALL := uv pip sync
else
	INSTALL := python -m pip install -r
endif

install:				## Install the developer tools
	$(INSTALL) requirements/dev.pip


##@ Tests and quality checks

.PHONY: lint smoke

lint:					## Run linters and checkers.
	tox -q -e lint

PYTEST_SMOKE_ARGS = -n auto -m "not expensive" --maxfail=3 $(ARGS)

smoke: 					## Run tests quickly with the C tracer in the lowest supported Python versions.
	COVERAGE_TEST_CORES=ctrace tox -q -e py38 -- $(PYTEST_SMOKE_ARGS)


##@ Metacov: coverage measurement of coverage.py itself
# See metacov.ini for details.

.PHONY: metacov metahtml metasmoke

metacov:				## Run meta-coverage, measuring ourself.
	COVERAGE_COVERAGE=yes tox -q $(ARGS)

metahtml:				## Produce meta-coverage HTML reports.
	tox exec -q $(ARGS) -- python3 igor.py combine_html

metasmoke:
	COVERAGE_TEST_CORES=ctrace ARGS="-e py39" make --keep-going metacov metahtml


##@ Requirements management

# When updating requirements, a few rules to follow:
#
# 1) Don't install more than one .pip file at once. Always use pip-compile to
# combine .in files onto a single .pip file that can be installed where needed.
#
# 2) Check manual pins before `make upgrade` to see if they can be removed. Look
# in requirements/pins.pip, and search for "windows" in .in files to find pins
# and extra requirements that have been needed, but might be obsolete.

.PHONY: upgrade upgrade_one _upgrade diff_upgrade

DOCBIN = .tox/doc/bin


PIP_COMPILE = uv pip compile -q ${COMPILE_OPTS}
upgrade: 				## Update the *.pip files with the latest packages satisfying *.in files.
	$(MAKE) _upgrade COMPILE_OPTS="--upgrade"

upgrade_one:				## Update the *.pip files for one package. `make upgrade_one package=...`
	@test -n "$(package)" || { echo "\nUsage: make upgrade-one package=...\n"; exit 1; }
	$(MAKE) _upgrade COMPILE_OPTS="--upgrade-package $(package)"

_upgrade: export UV_CUSTOM_COMPILE_COMMAND=make upgrade
_upgrade:
	$(PIP_COMPILE) -o requirements/pip.pip requirements/pip.in
	$(PIP_COMPILE) -o requirements/pytest.pip requirements/pytest.in
	$(PIP_COMPILE) -o requirements/kit.pip requirements/kit.in
	$(PIP_COMPILE) -o requirements/tox.pip requirements/tox.in
	$(PIP_COMPILE) -o requirements/dev.pip requirements/dev.in
	$(PIP_COMPILE) -o requirements/light-threads.pip requirements/light-threads.in
	$(PIP_COMPILE) -o requirements/mypy.pip requirements/mypy.in
	$(PIP_COMPILE) -p $(DOCBIN)/python3 -o doc/requirements.pip doc/requirements.in

diff_upgrade:				## Summarize the last `make upgrade`
	@# The sort flags sort by the package name first, then by the -/+, and
	@# sort by version numbers, so we get a summary with lines like this:
	@#	-bashlex==0.16
	@#	+bashlex==0.17
	@#	-build==0.9.0
	@#	+build==0.10.0
	@git diff -U0 | grep -v '^@' | grep == | sort -k1.2,1.99 -k1.1,1.1r -u -V


##@ Pre-builds for prepping the code

.PHONY: css workflows prebuild

CSS = coverage/htmlfiles/style.css
SCSS = coverage/htmlfiles/style.scss

css: $(CSS)				## Compile .scss into .css.
$(CSS): $(SCSS)
	pysassc --style=compact $(SCSS) $@
	cp $@ tests/gold/html/styled

workflows:				## Run cog on the workflows to keep them up-to-date.
	python -m cogapp -crP .github/workflows/*.yml

prebuild: css workflows cogdoc		## One command for all source prep.


##@ Sample HTML reports

.PHONY: _sample_cog_html sample_html sample_html_beta

_sample_cog_html: clean
	python -m pip install -e .
	cd ~/cog; \
		rm -rf htmlcov; \
		PYTEST_ADDOPTS= coverage run --branch --source=cogapp -m pytest -k CogTestsInMemory; \
		coverage combine; \
		coverage html

sample_html: _sample_cog_html		## Generate sample HTML report.
	rm -f doc/sample_html/*.*
	cp -r ~/cog/htmlcov/ doc/sample_html/
	rm doc/sample_html/.gitignore

sample_html_beta: _sample_cog_html	## Generate sample HTML report for a beta release.
	rm -f doc/sample_html_beta/*.*
	cp -r ~/cog/htmlcov/ doc/sample_html_beta/
	rm doc/sample_html_beta/.gitignore


##@ Kitting: making releases

.PHONY: release_version edit_for_release cheats relbranch relcommit1 relcommit2
.PHONY: kit pypi_upload test_upload kit_local build_kits update_rtd
.PHONY: tag bump_version

REPO_OWNER = nedbat/coveragepy
RTD_PROJECT = coverage

release_version:			#: Update the version for a release.
	python igor.py release_version

edit_for_release:			#: Edit sources to insert release facts (see howto.txt).
	python igor.py edit_for_release

cheats:					## Create some useful snippets for releasing.
	python igor.py cheats | tee cheats.txt

relbranch:				#: Create the branch for releasing (see howto.txt).
	git switch -c nedbat/release-$$(date +%Y%m%d-%H%M%S)

relcommit1:				#: Commit the first release changes (see howto.txt).
	git commit -am "docs: prep for $$(python setup.py --version)"

relcommit2:				#: Commit the latest sample HTML report (see howto.txt).
	git add doc/sample_html
	git commit -am "docs: sample HTML for $$(python setup.py --version)"

kit:					## Make the source distribution.
	python -m build

pypi_upload:				## Upload the built distributions to PyPI.
	python ci/trigger_action.py $(REPO_OWNER) publish-pypi
	@echo "Use that^ URL to approve the upload"

test_upload:				## Upload the distributions to PyPI's testing server.
	python ci/trigger_action.py $(REPO_OWNER) publish-testpypi
	@echo "Use that^ URL to approve the upload"

kit_local:
	# pip.conf looks like this:
	#   [global]
	#   find-links = file:///Users/ned/Downloads/local_pypi
	cp -v dist/* `awk -F "//" '/find-links/ {print $$2}' ~/.pip/pip.conf`
	# pip caches wheels of things it has installed. Clean them out so we
	# don't go crazy trying to figure out why our new code isn't installing.
	find ~/Library/Caches/pip/wheels -name 'coverage-*' -delete

build_kits:				## Trigger GitHub to build kits
	python ci/trigger_action.py $(REPO_OWNER) build-kits

tag:					#: Make a git tag with the version number (see howto.txt).
	git tag -s -m "Version $$(python setup.py --version)" $$(python setup.py --version)
	git push --follow-tags

update_rtd:				#: Update ReadTheDocs with the versions to show
	python ci/update_rtfd.py $(RTD_PROJECT)

bump_version:				#: Edit sources to bump the version after a release (see howto.txt).
	git switch -c nedbat/bump-version
	python igor.py bump_version
	git commit -a -m "build: bump version to $$(python setup.py --version | sed 's/a.*//')"
	git push -u origin @


##@ Documentation

.PHONY: cogdoc dochtml docdev docspell

SPHINXOPTS = -aE
SPHINXBUILD = $(DOCBIN)/sphinx-build $(SPHINXOPTS)
SPHINXAUTOBUILD = $(DOCBIN)/sphinx-autobuild --port 9876 --ignore '.git/**' --open-browser

$(DOCBIN):
	tox -q -e doc --notest

cogdoc: $(DOCBIN)			## Run docs through cog.
	$(DOCBIN)/python -m cogapp -crP --verbosity=1 doc/*.rst

dochtml: cogdoc $(DOCBIN)		## Build the docs HTML output.
	$(SPHINXBUILD) -b html doc doc/_build/html
	@echo "Start at: doc/_build/html/index.html"

docdev: dochtml				## Build docs, and auto-watch for changes.
	PATH=$(DOCBIN):$(PATH) $(SPHINXAUTOBUILD) -b html doc doc/_build/html

docspell: $(DOCBIN)			## Run the spell checker on the docs.
	# Very mac-specific...
	PYENCHANT_LIBRARY_PATH=/opt/homebrew/lib/libenchant-2.dylib $(SPHINXBUILD) -b spelling doc doc/_spell


##@ Publishing docs

.PHONY: publish publishbeta github_releases comment_on_fixes

WEBHOME = ~/web/stellated
WEBSAMPLE = $(WEBHOME)/files/sample_coverage_html
WEBSAMPLEBETA = $(WEBHOME)/files/sample_coverage_html_beta

publish:				## Publish the sample HTML report.
	rm -f $(WEBSAMPLE)/*.*
	mkdir -p $(WEBSAMPLE)
	cp doc/sample_html/*.* $(WEBSAMPLE)

publishbeta:
	rm -f $(WEBSAMPLEBETA)/*.*
	mkdir -p $(WEBSAMPLEBETA)
	cp doc/sample_html_beta/*.* $(WEBSAMPLEBETA)

CHANGES_MD = tmp/rst_rst/changes.md
SCRIV_SOURCE = tmp/only-changes.md

$(CHANGES_MD): CHANGES.rst $(DOCBIN)
	$(SPHINXBUILD) -b rst doc tmp/rst_rst
	pandoc -frst -tmarkdown_strict --markdown-headings=atx --wrap=none tmp/rst_rst/changes.rst > $(CHANGES_MD)

$(SCRIV_SOURCE): $(CHANGES_MD)
	@# Trim parts of the file that aren't changelog entries.
	sed -n -e '/## Version/,/## Earlier/p' < $(CHANGES_MD) > tmp/trimmed.md
	@# Replace sphinx references with published URLs.
	sed -r -e 's@]\(([a-zA-Z0-9_]+)\.rst#([^)]+)\)@](https://coverage.readthedocs.io/en/latest/\1.html#\2)@g' < tmp/trimmed.md > $(SCRIV_SOURCE)

github_releases: $(SCRIV_SOURCE)	## Update GitHub releases.
	$(DOCBIN)/python -m scriv github-release --all

comment_on_fixes: $(SCRIV_SOURCE)	## Add a comment to issues that were fixed.
	python ci/comment_on_fixes.py $(REPO_OWNER)

=== debian/changelog ===
python-coverage (7.8.2+dfsg1-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 13:50:23 +0000

python-coverage (7.8.2+dfsg1-1) unstable; urgency=medium

  * The “مریم میرزاخانی‎ (Maryam Mirzakhani)” release.
  * New upstream version.
    Highlights since previous release:
    * Support Python version 3.9 – 3.14.
    * Improvements to branch detection, avoiding some false positives
      (incorrectly detected missing branch coverage).
    * The `Coverage` initialiser can now receive plugin objects directly.
    * Documentation for measuring subprocesses now emphasises correct use of
      `multiprocessing`.
    * Generating XML report performance improved.
  * debian/patches/:
    * Refresh patches for new upstream version.
  * Declare conformance to “Standards-Version: 4.7.2”.
    No additional changes required.

 -- Ben Finney <bignose@debian.org>  Tue, 03 Jun 2025 16:31:49 +1000

=== debian/control ===
Source: python-coverage
Maintainer: Ben Finney <bignose@debian.org>
Section: python
Priority: optional
Build-Depends:
    dh-python,
    pybuild-plugin-pyproject,
    python3-sphinx,
    python3-sphinx-code-tabs,
    python3-sphinx-rtd-theme,
    python3-sphinxcontrib.restbuilder,
    python3-sphinxcontrib.spelling,
    python3-setuptools,
    python3-all-dev,
    python3,
    debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: https://coverage.readthedocs.io/
VCS-Git: https://salsa.debian.org/debian/pkg-python-coverage.git
VCS-Browser: https://salsa.debian.org/debian/pkg-python-coverage/
Rules-Requires-Root: no

Package: python3-coverage
Architecture: any
Depends:
    ${python3:Depends},
    ${shlibs:Depends},
    ${misc:Depends}
Suggests:
    python-coverage-doc
Description: code coverage tool for Python 3
 Coverage.py is a tool for measuring code coverage of Python programs.
 It monitors your program, noting which parts of the code have been
 executed, then analyzes the source to identify code that could have
 been executed but was not.
 .
 Coverage measurement is typically used to gauge the effectiveness of
 tests. It can show which parts of your code are being exercised by
 tests, and which are not.
 .
 This package installs the Python version 3 ‘coverage’ library, and the
 ‘python3-coverage’ program to perform and report coverage tests.

Package: python-coverage-doc
Architecture: all
Section: doc
Depends:
    ${sphinxdoc:Depends},
    ${misc:Depends}
Description: code coverage tool for Python — documentation
 Coverage.py is a tool for measuring code coverage of Python programs.
 It monitors your program, noting which parts of the code have been
 executed, then analyzes the source to identify code that could have
 been executed but was not.
 .
 This package installs the HTML documentation for Coverage.py.

=== debian/rules ===
#! /usr/bin/make -f
#
# debian/rules
# Part of the Debian ‘python-coverage’ package.
#
# This is free software, and you are welcome to redistribute it under
# certain conditions; see the end of this file for copyright
# information, grant of license, and disclaimer of warranty.

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_NAME = coverage
export PYBUILD_DISABLE = test
export PYBUILD_SYSTEM = distutils

PYTHON3_PACKAGE_NAME = python3-${PYBUILD_NAME}
package_working_root = debian
package_install_root = debian/{package}

DISTRIBUTION_NAME = coverage

HTMLFILES_DIR = ${DISTRIBUTION_NAME}/htmlfiles
htmlfiles_dirname = $(notdir ${HTMLFILES_DIR})

RESOURCES_DIR = usr/share/{package}
package_install_resources_root = ${package_install_root}/${RESOURCES_DIR}

DOCUMENTATION_DIR = doc
MANPAGE_SUFFIX = .1
manpage_tempfile_suffix = ${MANPAGE_SUFFIX}.tmp
default_manpage_name = python-coverage${MANPAGE_SUFFIX}
python_command_path = ${package_install_root}/usr/bin/python-coverage
python3_command_names = $(sort $(notdir $(wildcard \
	${package_working_root}/*/usr/bin/python3*-coverage)))
versioned_command_names = ${python3_command_names}
versioned_manpage_names = $(addsuffix ${MANPAGE_SUFFIX}, \
	${versioned_command_names})
versioned_manpage_paths = $(addprefix ${DOCUMENTATION_DIR}/, \
	${versioned_manpage_names})
GENERATED_FILES += ${DOCUMENTATION_DIR}/*${MANPAGE_SUFFIX}
GENERATED_FILES += ${DOCUMENTATION_DIR}/*${manpage_tempfile_suffix}

DOCUMENTATION_BUILD_DIR = ${DOCUMENTATION_DIR}/_build
DOCUMENTATION_BUILD_HTML_DIR = ${DOCUMENTATION_BUILD_DIR}/html
DOCUMENTATION_BUILD_PYCACHE_DIR = ${DOCUMENTATION_BUILD_HTML_DIR}/_static/__pycache__
GENERATED_FILES += ${DOCUMENTATION_BUILD_DIR}

INSTALL = install
MV = mv
CP = cp

# Send HTTP traffic to the “discard” service during packaging actions.
export http_proxy = http://127.0.1.1:9/
export https_proxy = ${http_proxy}

RST_SUFFIX = .txt

RST2MAN = rst2man

SPHINX = python3 -m sphinx
SPHINX_OPTS = -N

FIX_SHEBANG = debian/fix_shebang


%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild


.PHONY: manpage-aliases
manpage-aliases: ${versioned_manpage_paths}

${DOCUMENTATION_DIR}:
	$(INSTALL) --directory "$@"

${DOCUMENTATION_DIR}/${default_manpage_name}: ${DOCUMENTATION_DIR}
${DOCUMENTATION_DIR}/${default_manpage_name}: ${package_working_root}/${default_manpage_name}
	$(INSTALL) --mode=u=rw,go=r "$<" "$@"

${DOCUMENTATION_DIR}/%${MANPAGE_SUFFIX}: ${DOCUMENTATION_DIR}/${default_manpage_name}
	$(INSTALL) --mode=u=rw,go=r "$<" "$@"

%.1: %.1${RST_SUFFIX}
	$(RST2MAN) "$<" > "$@".tmp
	cat debian/manpage_encoding_declaration.UTF-8 "$@".tmp > "$@"


override_dh_auto_build:
	dh_auto_build --buildsystem=pybuild
	$(SPHINX) ${SPHINX_OPTS} -bhtml ${DOCUMENTATION_DIR}/ \
		${DOCUMENTATION_BUILD_HTML_DIR}/
	$(RM) -r ${DOCUMENTATION_BUILD_PYCACHE_DIR}/

# Upstream test suite doesn't currently run in our build environment.
override_dh_auto_test:

export PYBUILD_AFTER_INSTALL = \
	$(INSTALL) --mode=u=rwx,go=rx --directory \
	    "${package_install_resources_root}" ; \
	$(INSTALL) --mode=u=rwx,go=rx --directory \
	    "${package_install_resources_root}/${htmlfiles_dirname}" ; \
	$(INSTALL) --mode=u=rw,go=r "${HTMLFILES_DIR}"/* \
	    "${package_install_resources_root}/${htmlfiles_dirname}" ; \
	dh_link \
	    --package={package} \
	    "/${RESOURCES_DIR}/${htmlfiles_dirname}" \
	    {install_dir}/${HTMLFILES_DIR} ; \
	$(CP) ${python_command_path} \
	    ${package_install_root}/usr/bin/python{version}-coverage ; \
	$(FIX_SHEBANG) --interpreter 'usr/bin/python{version}' \
	    ${package_install_root}/usr/bin/python{version}-coverage ; \
	$(MV) ${python_command_path} \
	    ${package_install_root}/usr/bin/python{version.major}-coverage ; \
	$(FIX_SHEBANG) --interpreter 'usr/bin/python{version.major}' \
	    ${package_install_root}/usr/bin/python{version.major}-coverage

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.rst

override_dh_installman: manpage-aliases
	dh_installman

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r ${GENERATED_FILES}


# Copyright © 2010–2025 Ben Finney <bignose@debian.org>
# This is free software: you may copy, modify, and/or distribute this work
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; version 3 of that license or any later version.
# No warranty expressed or implied.


# Local variables:
# coding: utf-8
# mode: makefile
# End:
# vim: fileencoding=utf-8 filetype=make :

=== debian/tests/control ===
# debian/tests/control
# Control file for Debian ‘autopkgtests’.
# Documentation: ‘/usr/share/doc/autopkgtest/README.package-tests.rst.gz’.
#
# This is free software, and you are welcome to redistribute it under
# certain conditions; see the end of this file for copyright
# information, grant of license, and disclaimer of warranty.

Tests: smoke-python3
Restrictions:
    superficial
Depends:
    python3-package-smoke-test,
    python3-all,
    @

Test-Command:
    w3m -dump /usr/share/doc/python-coverage-doc/html/index.html > /dev/null
Restrictions:
    superficial
    build-needed
Depends:
    python-coverage-doc,
    w3m

Test-Command:
    file --brief /usr/share/doc/python-coverage-doc/html/index.html
        | grep -q 'HTML document'
Restrictions:
    superficial
    build-needed
Depends:
    python-coverage-doc,
    file

Tests: entry-point-scripts
Depends:
    python3-all,
    @

Tests: module-scripts
Depends:
    python3-all,
    @


# Copyright © 2016–2025 Ben Finney <bignose@debian.org>
# This is free software: you may copy, modify, and/or distribute this work
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; version 3 of that license or any later version.
# No warranty expressed or implied.


# Local variables:
# coding: utf-8
# mode: conf-space
# End:
# vim: fileencoding=utf-8 filetype=conf :

=== debian/watch ===
# debian/watch
# Debian UScan configuration for this package.
# Manual page: ‘uscan(1)’.

# Version of UScan configuration format.
version = 4

# Source tarball from Python Package Index.
opts = "uversionmangle=s/(\d)((?:a|b|c|rc)\d*)$/$1~$2/,repack,repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d+$//" \
    https://pypi.debian.net/coverage/ \
    /coverage/coverage-@ANY_VERSION@@ARCHIVE_EXT@ \
    debian uupdate


# Local variables:
# coding: utf-8
# mode: conf
# End:
# vim: fileencoding=utf-8 filetype=conf :
